/*
  ------------------------------------------------------------------------------

    Copyright © 2005-2011, Tommi T. Järvi
                           tommi . jarvi @ iki . fi (remove spaces)


    This file is part of one of my programs.

    This is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2,
    as published by the Free Software Foundation.

    This is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this file; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  ------------------------------------------------------------------------------
*/


#include <cmath>
#include <string>
#include <iostream>
#include <sstream>
#include <valarray>

using namespace std;


// Mersenne Twister RNG
#define genrand genrand_real3
#define sgenrand init_genrand
extern "C" {
#include "mt19937ar.h"
}


// math
double norm(valarray<double> &x);
double normsq(valarray<double> &x);
void normalise3v(valarray<double> &x);  // normalise x0-type vector by three vectors
void normalto3v(valarray<double> &x, const valarray<double> &normal);
void normalto3v(double *x, int n, const valarray<double> &normal);
double gaussian();
double gaussian(double sigma);


// arrays
double* grow(double *x, int n1, int n2);  // resize x, n1->n2
int* grow(int *x, int n1, int n2);
int pickrandom(valarray<double> x);  // pick i with prob. corr. to x[i]

// strings
string stringify(int n);
string stringify(double n);
string tolower(string st);
